package com.tencent.youshu.sr_tracksdk_flutter_plugin;

import android.content.Context;

import androidx.annotation.NonNull;
import org.json.JSONObject;
import java.util.List;
import java.util.Map;

import io.flutter.embedding.engine.plugins.FlutterPlugin;
import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;
import io.flutter.plugin.common.MethodChannel.MethodCallHandler;
import io.flutter.plugin.common.MethodChannel.Result;
import com.qq.wetrack.action.SR;

/** SrTracksdkFlutterPlugin */
public class SrTracksdkFlutterPlugin implements FlutterPlugin, MethodCallHandler {
  /// The MethodChannel that will the communication between Flutter and native Android
  ///
  /// This local reference serves to register the plugin with the Flutter Engine and unregister it
  /// when the Flutter Engine is detached from the Activity
  private MethodChannel channel;
  private Context context;

  @Override
  public void onAttachedToEngine(@NonNull FlutterPluginBinding flutterPluginBinding) {
    channel = new MethodChannel(flutterPluginBinding.getBinaryMessenger(), "sr_tracksdk_flutter_plugin");
    channel.setMethodCallHandler(this);
    this.context = flutterPluginBinding.getApplicationContext();
  }

  @Override
  public void onMethodCall(@NonNull MethodCall call, @NonNull Result result) {
    try {
      List list = (List) call.arguments;
      switch (call.method) {
        case "track":
          track(list);
          break;
        case "trackNull":
          trackNull(list);
          break;
        case "init":
          init(list);
          break;
        case "setUser":
          setUser(list);
          break;
      }
    } catch (Exception e) {
      e.printStackTrace();
    }
  }

  /**
   * track
   */
  private void track(List list) {
    Map<String, Object> map = (Map<String, Object>) list.get(1);
    JSONObject obj= new JSONObject(map);
    SR.track((String) list.get(0), obj);
  }

  /**
   * trackEventName
   */
  private void trackNull(List list) {
    SR.track((String) list.get(0));
  }

  /**
   * init
   */
  private void init(List list) {
    SR.init(this.context, (String) list.get(0),(String) list.get(1),(String) list.get(2));
  }

  /**
   * setUser
   */
  private void setUser(List list) {
    SR.setUser((String) list.get(0));
  }

  @Override
  public void onDetachedFromEngine(@NonNull FlutterPluginBinding binding) {
    channel.setMethodCallHandler(null);
  }
}
